Index: branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/SyntaxElementWriter.h
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/SyntaxElementWriter.h	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/SyntaxElementWriter.h	(revision 1200)
@@ -2,7 +2,7 @@
  * License, included below. This software may be subject to other third party
  * and contributor rights, including patent rights, and no such rights are
- * granted under this license.  
+ * granted under this license.
  *
-* Copyright (c) 2010-2015, ITU/ISO/IEC
+ * Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -88,4 +88,5 @@
   Void  xWriteFlagTr          ( UInt value,               const Char *pSymbolName);
 #endif
+  Void xWriteRbspTrailingBits();
 
   UInt  xConvertToUInt        ( Int iValue ) {  return ( iValue <= 0) ? -iValue<<1 : (iValue<<1)-1; }
Index: branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/TEncAnalyze.h
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/TEncAnalyze.h	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/TEncAnalyze.h	(revision 1200)
@@ -2,7 +2,7 @@
  * License, included below. This software may be subject to other third party
  * and contributor rights, including patent rights, and no such rights are
- * granted under this license.  
+ * granted under this license.
  *
-* Copyright (c) 2010-2015, ITU/ISO/IEC
+ * Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -47,4 +47,6 @@
 #include <assert.h>
 #include "TLibCommon/CommonDef.h"
+#include "TLibCommon/TComChromaFormat.h"
+#include "math.h"
 
 //! \ingroup TLibEncoder
@@ -59,125 +61,324 @@
 {
 private:
-  Double    m_dPSNRSumY;
-  Double    m_dPSNRSumU;
-  Double    m_dPSNRSumV;
+  Double    m_dPSNRSum[MAX_NUM_COMPONENT];
   Double    m_dAddBits;
   UInt      m_uiNumPic;
   Double    m_dFrmRate; //--CFG_KDY
-  
+  Double    m_MSEyuvframe[MAX_NUM_COMPONENT]; // sum of MSEs
+
 public:
-  TEncAnalyze() { m_dPSNRSumY = m_dPSNRSumU = m_dPSNRSumV = m_dAddBits = m_uiNumPic = 0;  }
   virtual ~TEncAnalyze()  {}
-  
-  Void  addResult( Double psnrY, Double psnrU, Double psnrV, Double bits)
-  {
-    m_dPSNRSumY += psnrY;
-    m_dPSNRSumU += psnrU;
-    m_dPSNRSumV += psnrV;
+  TEncAnalyze() { clear(); }
+
+  Void  addResult( Double psnr[MAX_NUM_COMPONENT], Double bits, const Double MSEyuvframe[MAX_NUM_COMPONENT])
+  {
     m_dAddBits  += bits;
-    
+    for(UInt i=0; i<MAX_NUM_COMPONENT; i++)
+    {
+      m_dPSNRSum[i] += psnr[i];
+      m_MSEyuvframe[i] += MSEyuvframe[i];
+    }
+
     m_uiNumPic++;
   }
-  
-  Double  getPsnrY()  { return  m_dPSNRSumY;  }
-  Double  getPsnrU()  { return  m_dPSNRSumU;  }
-  Double  getPsnrV()  { return  m_dPSNRSumV;  }
-  Double  getBits()   { return  m_dAddBits;   }
-  UInt    getNumPic() { return  m_uiNumPic;   }
-  
+
+  Double  getPsnr(ComponentID compID) const { return  m_dPSNRSum[compID];  }
+  Double  getBits()                   const { return  m_dAddBits;   }
+  Void    setBits(Double numBits)     { m_dAddBits=numBits; }
+  UInt    getNumPic()                 const { return  m_uiNumPic;   }
+
   Void    setFrmRate  (Double dFrameRate) { m_dFrmRate = dFrameRate; } //--CFG_KDY
-  Void    clear() { m_dPSNRSumY = m_dPSNRSumU = m_dPSNRSumV = m_dAddBits = m_uiNumPic = 0;  }
-  Void    printOut ( Char cDelim )
+  Void    clear()
+  {
+    m_dAddBits = 0;
+    for(UInt i=0; i<MAX_NUM_COMPONENT; i++)
+    {
+      m_dPSNRSum[i] = 0;
+      m_MSEyuvframe[i] = 0;
+    }
+    m_uiNumPic = 0;
+  }
+
+
+  Void calculateCombinedValues(const ChromaFormat chFmt, Double &PSNRyuv, Double &MSEyuv, const BitDepths &bitDepths)
+  {
+    MSEyuv    = 0;
+    Int scale = 0;
+
+    Int maximumBitDepth = bitDepths.recon[CHANNEL_TYPE_LUMA];
+    for (UInt channelTypeIndex = 1; channelTypeIndex < MAX_NUM_CHANNEL_TYPE; channelTypeIndex++)
+    {
+      if (bitDepths.recon[channelTypeIndex] > maximumBitDepth)
+      {
+        maximumBitDepth = bitDepths.recon[channelTypeIndex];
+      }
+    }
+
+    const UInt maxval                = 255 << (maximumBitDepth - 8);
+    const UInt numberValidComponents = getNumberValidComponents(chFmt);
+
+    for (UInt comp=0; comp<numberValidComponents; comp++)
+    {
+      const ComponentID compID        = ComponentID(comp);
+      const UInt        csx           = getComponentScaleX(compID, chFmt);
+      const UInt        csy           = getComponentScaleY(compID, chFmt);
+      const Int         scaleChan     = (4>>(csx+csy));
+      const UInt        bitDepthShift = 2 * (maximumBitDepth - bitDepths.recon[toChannelType(compID)]); //*2 because this is a squared number
+
+      const Double      channelMSE    = (m_MSEyuvframe[compID] * Double(1 << bitDepthShift)) / Double(getNumPic());
+
+      scale  += scaleChan;
+      MSEyuv += scaleChan * channelMSE;
+    }
+
+    MSEyuv /= Double(scale);  // i.e. divide by 6 for 4:2:0, 8 for 4:2:2 etc.
+    PSNRyuv = (MSEyuv==0 ? 999.99 : 10*log10((maxval*maxval)/MSEyuv));
+  }
+
+
+  Void    printOut ( Char cDelim, const ChromaFormat chFmt, const Bool printMSEBasedSNR, const Bool printSequenceMSE, const BitDepths &bitDepths )
   {
     Double dFps     =   m_dFrmRate; //--CFG_KDY
     Double dScale   = dFps / 1000 / (Double)m_uiNumPic;
-    
-    printf( "\tTotal Frames |  "   "Bitrate    "  "Y-PSNR    "  "U-PSNR    "  "V-PSNR \n" );
-    //printf( "\t------------ "  " ----------"   " -------- "  " -------- "  " --------\n" );
-    printf( "\t %8d    %c"          "%12.4lf  "    "%8.4lf  "   "%8.4lf  "    "%8.4lf\n",
-           getNumPic(), cDelim,
-           getBits() * dScale,
-           getPsnrY() / (Double)getNumPic(),
-           getPsnrU() / (Double)getNumPic(),
-           getPsnrV() / (Double)getNumPic() );
-  }
-  
-  Void    printSummaryOut ()
-  {
-    FILE* pFile = fopen ("summaryTotal.txt", "at");
+
+    Double MSEBasedSNR[MAX_NUM_COMPONENT];
+    if (printMSEBasedSNR)
+    {
+      for (UInt componentIndex = 0; componentIndex < MAX_NUM_COMPONENT; componentIndex++)
+      {
+        const ComponentID compID = ComponentID(componentIndex);
+
+        if (getNumPic() == 0)
+        {
+          MSEBasedSNR[compID] = 0 * dScale; // this is the same calculation that will be evaluated for any other statistic when there are no frames (it should result in NaN). We use it here so all the output is consistent.
+        }
+        else
+        {
+          //NOTE: this is not the true maximum value for any bitDepth other than 8. It comes from the original HM PSNR calculation
+          const UInt maxval = 255 << (bitDepths.recon[toChannelType(compID)] - 8);
+          const Double MSE = m_MSEyuvframe[compID];
+
+          MSEBasedSNR[compID] = (MSE == 0) ? 999.99 : (10 * log10((maxval * maxval) / (MSE / (Double)getNumPic())));
+        }
+      }
+    }
+
+    switch (chFmt)
+    {
+      case CHROMA_400:
+        if (printMSEBasedSNR)
+        {
+          printf( "         \tTotal Frames |   "   "Bitrate     "  "Y-PSNR" );
+
+          if (printSequenceMSE)
+          {
+            printf( "    Y-MSE\n" );
+          }
+          else
+          {
+            printf("\n");
+          }
+
+          //printf( "\t------------ "  " ----------"   " -------- "  " -------- "  " --------\n" );
+          printf( "Average: \t %8d    %c "          "%12.4lf  "    "%8.4lf",
+                 getNumPic(), cDelim,
+                 getBits() * dScale,
+                 getPsnr(COMPONENT_Y) / (Double)getNumPic() );
+
+          if (printSequenceMSE)
+          {
+            printf( "  %8.4lf\n", m_MSEyuvframe[COMPONENT_Y ] / (Double)getNumPic() );
+          }
+          else
+          {
+            printf("\n");
+          }
+
+          printf( "From MSE:\t %8d    %c "          "%12.4lf  "    "%8.4lf\n",
+                 getNumPic(), cDelim,
+                 getBits() * dScale,
+                 MSEBasedSNR[COMPONENT_Y] );
+        }
+        else
+        {
+          printf( "\tTotal Frames |   "   "Bitrate     "  "Y-PSNR" );
+
+          if (printSequenceMSE)
+          {
+            printf( "    Y-MSE\n" );
+          }
+          else
+          {
+            printf("\n");
+          }
+
+          //printf( "\t------------ "  " ----------"   " -------- "  " -------- "  " --------\n" );
+          printf( "\t %8d    %c "          "%12.4lf  "    "%8.4lf",
+                 getNumPic(), cDelim,
+                 getBits() * dScale,
+                 getPsnr(COMPONENT_Y) / (Double)getNumPic() );
+
+          if (printSequenceMSE)
+          {
+            printf( "  %8.4lf\n", m_MSEyuvframe[COMPONENT_Y ] / (Double)getNumPic() );
+          }
+          else
+          {
+            printf("\n");
+          }
+        }
+        break;
+      case CHROMA_420:
+      case CHROMA_422:
+      case CHROMA_444:
+        {
+          Double PSNRyuv = MAX_DOUBLE;
+          Double MSEyuv  = MAX_DOUBLE;
+          
+          calculateCombinedValues(chFmt, PSNRyuv, MSEyuv, bitDepths);
+
+          if (printMSEBasedSNR)
+          {
+            printf( "         \tTotal Frames |   "   "Bitrate     "  "Y-PSNR    "  "U-PSNR    "  "V-PSNR    "  "YUV-PSNR " );
+
+            if (printSequenceMSE)
+            {
+              printf( " Y-MSE     "  "U-MSE     "  "V-MSE    "  "YUV-MSE \n" );
+            }
+            else
+            {
+              printf("\n");
+            }
+
+            //printf( "\t------------ "  " ----------"   " -------- "  " -------- "  " --------\n" );
+            printf( "Average: \t %8d    %c "          "%12.4lf  "    "%8.4lf  "   "%8.4lf  "    "%8.4lf  "   "%8.4lf",
+                   getNumPic(), cDelim,
+                   getBits() * dScale,
+                   getPsnr(COMPONENT_Y) / (Double)getNumPic(),
+                   getPsnr(COMPONENT_Cb) / (Double)getNumPic(),
+                   getPsnr(COMPONENT_Cr) / (Double)getNumPic(),
+                   PSNRyuv );
+
+            if (printSequenceMSE)
+            {
+              printf( "  %8.4lf  "   "%8.4lf  "    "%8.4lf  "   "%8.4lf\n",
+                     m_MSEyuvframe[COMPONENT_Y ] / (Double)getNumPic(),
+                     m_MSEyuvframe[COMPONENT_Cb] / (Double)getNumPic(),
+                     m_MSEyuvframe[COMPONENT_Cr] / (Double)getNumPic(),
+                     MSEyuv );
+            }
+            else
+            {
+              printf("\n");
+            }
+
+            printf( "From MSE:\t %8d    %c "          "%12.4lf  "    "%8.4lf  "   "%8.4lf  "    "%8.4lf  "   "%8.4lf\n",
+                   getNumPic(), cDelim,
+                   getBits() * dScale,
+                   MSEBasedSNR[COMPONENT_Y],
+                   MSEBasedSNR[COMPONENT_Cb],
+                   MSEBasedSNR[COMPONENT_Cr],
+                   PSNRyuv );
+          }
+          else
+          {
+            printf( "\tTotal Frames |   "   "Bitrate     "  "Y-PSNR    "  "U-PSNR    "  "V-PSNR    "  "YUV-PSNR " );
+            
+            if (printSequenceMSE)
+            {
+              printf( " Y-MSE     "  "U-MSE     "  "V-MSE    "  "YUV-MSE \n" );
+            }
+            else
+            {
+              printf("\n");
+            }
+
+            //printf( "\t------------ "  " ----------"   " -------- "  " -------- "  " --------\n" );
+            printf( "\t %8d    %c "          "%12.4lf  "    "%8.4lf  "   "%8.4lf  "    "%8.4lf  "   "%8.4lf",
+                   getNumPic(), cDelim,
+                   getBits() * dScale,
+                   getPsnr(COMPONENT_Y) / (Double)getNumPic(),
+                   getPsnr(COMPONENT_Cb) / (Double)getNumPic(),
+                   getPsnr(COMPONENT_Cr) / (Double)getNumPic(),
+                   PSNRyuv );
+
+            if (printSequenceMSE)
+            {
+              printf( "  %8.4lf  "   "%8.4lf  "    "%8.4lf  "   "%8.4lf\n",
+                     m_MSEyuvframe[COMPONENT_Y ] / (Double)getNumPic(),
+                     m_MSEyuvframe[COMPONENT_Cb] / (Double)getNumPic(),
+                     m_MSEyuvframe[COMPONENT_Cr] / (Double)getNumPic(),
+                     MSEyuv );
+            }
+            else
+            {
+              printf("\n");
+            }
+          }
+        }
+        break;
+      default:
+        fprintf(stderr, "Unknown format during print out\n");
+        exit(1);
+        break;
+    }
+  }
+
+
+  Void    printSummary(const ChromaFormat chFmt, const Bool printSequenceMSE, const BitDepths &bitDepths, const std::string &sFilename)
+  {
+    FILE* pFile = fopen (sFilename.c_str(), "at");
+
     Double dFps     =   m_dFrmRate; //--CFG_KDY
     Double dScale   = dFps / 1000 / (Double)m_uiNumPic;
-    
-    fprintf(pFile, "%f\t %f\t %f\t %f\n", getBits() * dScale,
-            getPsnrY() / (Double)getNumPic(),
-            getPsnrU() / (Double)getNumPic(),
-            getPsnrV() / (Double)getNumPic() );
+    switch (chFmt)
+    {
+      case CHROMA_400:
+        fprintf(pFile, "%f\t %f\n",
+            getBits() * dScale,
+            getPsnr(COMPONENT_Y) / (Double)getNumPic() );
+        break;
+      case CHROMA_420:
+      case CHROMA_422:
+      case CHROMA_444:
+        {
+          Double PSNRyuv = MAX_DOUBLE;
+          Double MSEyuv  = MAX_DOUBLE;
+          
+          calculateCombinedValues(chFmt, PSNRyuv, MSEyuv, bitDepths);
+
+          fprintf(pFile, "%f\t %f\t %f\t %f\t %f",
+              getBits() * dScale,
+              getPsnr(COMPONENT_Y) / (Double)getNumPic(),
+              getPsnr(COMPONENT_Cb) / (Double)getNumPic(),
+              getPsnr(COMPONENT_Cr) / (Double)getNumPic(),
+              PSNRyuv );
+
+          if (printSequenceMSE)
+          {
+            fprintf(pFile, "\t %f\t %f\t %f\t %f\n",
+                m_MSEyuvframe[COMPONENT_Y ] / (Double)getNumPic(),
+                m_MSEyuvframe[COMPONENT_Cb] / (Double)getNumPic(),
+                m_MSEyuvframe[COMPONENT_Cr] / (Double)getNumPic(),
+                MSEyuv );
+          }
+          else
+          {
+            fprintf(pFile, "\n");
+          }
+
+          break;
+        }
+
+      default:
+          fprintf(stderr, "Unknown format during print out\n");
+          exit(1);
+          break;
+    }
+
     fclose(pFile);
   }
-  
-  Void    printOutInterlaced ( Char cDelim, Double bits )
-  {
-    Double dFps     =   m_dFrmRate; //--CFG_KDY
-    Double dScale   = dFps / 1000 / (Double)m_uiNumPic;
-    
-    printf( "\tTotal Frames |  "   "Bitrate    "  "Y-PSNR    "  "U-PSNR    "  "V-PSNR \n" );
-    //printf( "\t------------ "  " ----------"   " -------- "  " -------- "  " --------\n" );
-    printf( "\t %8d    %c"          "%12.4lf  "    "%8.4lf  "   "%8.4lf  "    "%8.4lf\n",
-           getNumPic(), cDelim,
-           bits * dScale,
-           getPsnrY() / (Double)getNumPic(),
-           getPsnrU() / (Double)getNumPic(),
-           getPsnrV() / (Double)getNumPic() );
-  }
-  
-  Void    printSummaryOutInterlaced (Int bits)
-  {
-    FILE* pFile = fopen ("summaryTotal.txt", "at");
-    Double dFps     =   m_dFrmRate; //--CFG_KDY
-    Double dScale   = dFps / 1000 / (Double)m_uiNumPic;
-    
-    fprintf(pFile, "%f\t %f\t %f\t %f\n", bits * dScale,
-            getPsnrY() / (Double)getNumPic(),
-            getPsnrU() / (Double)getNumPic(),
-            getPsnrV() / (Double)getNumPic() );
-    fclose(pFile);
-  }
-  
-  
-  Void    printSummary(Char ch)
-  {
-    FILE* pFile = NULL;
-    
-    switch( ch ) 
-    {
-      case 'I':
-        pFile = fopen ("summary_I.txt", "at");
-        break;
-      case 'P':
-        pFile = fopen ("summary_P.txt", "at");
-        break;
-      case 'B':
-        pFile = fopen ("summary_B.txt", "at");
-        break;
-      default:
-        assert(0);
-        return;
-        break;
-    }
-    
-    Double dFps     =   m_dFrmRate; //--CFG_KDY
-    Double dScale   = dFps / 1000 / (Double)m_uiNumPic;
-    
-    fprintf(pFile, "%f\t %f\t %f\t %f\n",
-            getBits() * dScale,
-            getPsnrY() / (Double)getNumPic(),
-            getPsnrU() / (Double)getNumPic(),
-            getPsnrV() / (Double)getNumPic() );
-    
-    fclose(pFile);
-  }
 };
 
-#if !H_MV
 extern TEncAnalyze             m_gcAnalyzeAll;
 extern TEncAnalyze             m_gcAnalyzeI;
@@ -186,5 +387,4 @@
 
 extern TEncAnalyze             m_gcAnalyzeAll_in;
-#endif
 
 //! \}
Index: branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/TEncBinCoder.h
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/TEncBinCoder.h	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/TEncBinCoder.h	(revision 1200)
@@ -2,7 +2,7 @@
  * License, included below. This software may be subject to other third party
  * and contributor rights, including patent rights, and no such rights are
- * granted under this license.  
+ * granted under this license.
  *
-* Copyright (c) 2010-2015, ITU/ISO/IEC
+ * Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -36,6 +36,6 @@
 */
 
-#ifndef __TENC_BIN_CODER__
-#define __TENC_BIN_CODER__
+#ifndef __TENCBINCODER__
+#define __TENCBINCODER__
 
 #include "TLibCommon/ContextModel.h"
@@ -55,5 +55,5 @@
   virtual Void  start             ()                                          = 0;
   virtual Void  finish            ()                                          = 0;
-  virtual Void  copyState         ( TEncBinIf* pcTEncBinIf )                  = 0;
+  virtual Void  copyState         ( const TEncBinIf* pcTEncBinIf )            = 0;
   virtual Void  flush            ()                                           = 0;
 
@@ -70,6 +70,9 @@
   virtual Void  encodeBinTrm      ( UInt  uiBin                            )  = 0;
 
+  virtual Void  align             ()                                          = 0;
+
   virtual TEncBinCABAC*   getTEncBinCABAC   ()  { return 0; }
-  
+  virtual const TEncBinCABAC*   getTEncBinCABAC   () const { return 0; }
+
   virtual ~TEncBinIf() {}
 };
Index: branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/TEncBinCoderCABAC.cpp
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/TEncBinCoderCABAC.cpp	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/TEncBinCoderCABAC.cpp	(revision 1200)
@@ -2,7 +2,7 @@
  * License, included below. This software may be subject to other third party
  * and contributor rights, including patent rights, and no such rights are
- * granted under this license.  
- *
-* Copyright (c) 2010-2015, ITU/ISO/IEC
+ * granted under this license.
+ *
+ * Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -38,5 +38,5 @@
 #include "TEncBinCoderCABAC.h"
 #include "TLibCommon/TComRom.h"
-
+#include "TLibCommon/Debug.h"
 
 //! \ingroup TLibEncoder
@@ -74,4 +74,7 @@
   m_numBufferedBytes = 0;
   m_bufferedByte     = 0xff;
+#if FAST_BIT_EST
+  m_fracBits         = 0;
+#endif
 }
 
@@ -100,5 +103,5 @@
       m_pcTComBitIf->write( 0xff, 8 );
       m_numBufferedBytes--;
-    }    
+    }
   }
   m_pcTComBitIf->write( m_uiLow >> 8, 24 - m_bitsLeft );
@@ -143,7 +146,7 @@
 }
 
-Void TEncBinCABAC::copyState( TEncBinIf* pcTEncBinIf )
-{
-  TEncBinCABAC* pcTEncBinCABAC = pcTEncBinIf->getTEncBinCABAC();
+Void TEncBinCABAC::copyState( const TEncBinIf* pcTEncBinIf )
+{
+  const TEncBinCABAC* pcTEncBinCABAC = pcTEncBinIf->getTEncBinCABAC();
   m_uiLow           = pcTEncBinCABAC->m_uiLow;
   m_uiRange         = pcTEncBinCABAC->m_uiRange;
@@ -184,20 +187,24 @@
 Void TEncBinCABAC::encodeBin( UInt binValue, ContextModel &rcCtxModel )
 {
-  {
-#if !H_MV
-    DTRACE_CABAC_VL( g_nSymbolCounter++ )
-    DTRACE_CABAC_T( "\tstate=" )
-    DTRACE_CABAC_V( ( rcCtxModel.getState() << 1 ) + rcCtxModel.getMps() )
-    DTRACE_CABAC_T( "\tsymbol=" )
-    DTRACE_CABAC_V( binValue )
-    DTRACE_CABAC_T( "\n" )
-#endif
-  }
+#if !NH_MV
+  //{
+  //  DTRACE_CABAC_VL( g_nSymbolCounter++ )
+  //  DTRACE_CABAC_T( "\tstate=" )
+  //  DTRACE_CABAC_V( ( rcCtxModel.getState() << 1 ) + rcCtxModel.getMps() )
+  //  DTRACE_CABAC_T( "\tsymbol=" )
+  //  DTRACE_CABAC_V( binValue )
+  //  DTRACE_CABAC_T( "\n" )
+  //}
+#endif
+#if DEBUG_CABAC_BINS
+  const UInt startingRange = m_uiRange;
+#endif
+
   m_uiBinsCoded += m_binCountIncrement;
   rcCtxModel.setBinsCoded( 1 );
-  
+
   UInt  uiLPS   = TComCABACTables::sm_aucLPSTable[ rcCtxModel.getState() ][ ( m_uiRange >> 6 ) & 3 ];
   m_uiRange    -= uiLPS;
-  
+
   if( binValue != rcCtxModel.getMps() )
   {
@@ -206,21 +213,38 @@
     m_uiRange   = uiLPS << numBits;
     rcCtxModel.updateLPS();
-    
     m_bitsLeft -= numBits;
+    testAndWriteOut();
   }
   else
   {
     rcCtxModel.updateMPS();
-    if ( m_uiRange >= 256 )
-    {
-      return;
-    }
-    
-    m_uiLow <<= 1;
-    m_uiRange <<= 1;
-    m_bitsLeft--;
-  }
-  
-  testAndWriteOut();
+
+    if ( m_uiRange < 256 )
+    {
+      m_uiLow <<= 1;
+      m_uiRange <<= 1;
+      m_bitsLeft--;
+      testAndWriteOut();
+    }
+  }
+
+#if DEBUG_CABAC_BINS
+  if ((g_debugCounter + debugCabacBinWindow) >= debugCabacBinTargetLine)
+  {
+    std::cout << g_debugCounter << ": coding bin value " << binValue << ", range = [" << startingRange << "->" << m_uiRange << "]\n";
+  }
+
+  if (g_debugCounter >= debugCabacBinTargetLine)
+  {
+    Char breakPointThis;
+    breakPointThis = 7;
+  }
+  if (g_debugCounter >= (debugCabacBinTargetLine + debugCabacBinWindow))
+  {
+    exit(0);
+  }
+
+  g_debugCounter++;
+#endif
 }
 
@@ -232,6 +256,7 @@
 Void TEncBinCABAC::encodeBinEP( UInt binValue )
 {
-  {
-#if !H_MV
+  if (false)
+  {
+#if !NH_MV
     DTRACE_CABAC_VL( g_nSymbolCounter++ )
     DTRACE_CABAC_T( "\tEPsymbol=" )
@@ -240,5 +265,13 @@
 #endif
   }
+
   m_uiBinsCoded += m_binCountIncrement;
+
+  if (m_uiRange == 256)
+  {
+    encodeAlignedBinsEP(binValue, 1);
+    return;
+  }
+
   m_uiLow <<= 1;
   if( binValue )
@@ -247,5 +280,5 @@
   }
   m_bitsLeft--;
-  
+
   testAndWriteOut();
 }
@@ -260,32 +293,83 @@
 {
   m_uiBinsCoded += numBins & -m_binCountIncrement;
-  
-  for ( Int i = 0; i < numBins; i++ )
-  {
-#if !H_MV
-    DTRACE_CABAC_VL( g_nSymbolCounter++ )
-    DTRACE_CABAC_T( "\tEPsymbol=" )
-    DTRACE_CABAC_V( ( binValues >> ( numBins - 1 - i ) ) & 1 )
-    DTRACE_CABAC_T( "\n" )
-#endif
-  }
-  
+
+  if (false)
+  {
+    for ( Int i = 0; i < numBins; i++ )
+    {
+#if !NH_MV
+      DTRACE_CABAC_VL( g_nSymbolCounter++ )
+      DTRACE_CABAC_T( "\tEPsymbol=" )
+      DTRACE_CABAC_V( ( binValues >> ( numBins - 1 - i ) ) & 1 )
+      DTRACE_CABAC_T( "\n" )
+#endif
+    }
+  }
+
+  if (m_uiRange == 256)
+  {
+    encodeAlignedBinsEP(binValues, numBins);
+    return;
+  }
+
   while ( numBins > 8 )
   {
     numBins -= 8;
-    UInt pattern = binValues >> numBins; 
+    UInt pattern = binValues >> numBins;
     m_uiLow <<= 8;
     m_uiLow += m_uiRange * pattern;
     binValues -= pattern << numBins;
     m_bitsLeft -= 8;
-    
+
     testAndWriteOut();
   }
-  
+
   m_uiLow <<= numBins;
   m_uiLow += m_uiRange * binValues;
   m_bitsLeft -= numBins;
-  
+
   testAndWriteOut();
+}
+
+Void TEncBinCABAC::align()
+{
+  m_uiRange = 256;
+}
+
+Void TEncBinCABAC::encodeAlignedBinsEP( UInt binValues, Int numBins )
+{
+  Int binsRemaining = numBins;
+
+  assert(m_uiRange == 256); //aligned encode only works when range = 256
+
+  while (binsRemaining > 0)
+  {
+    const UInt binsToCode = std::min<UInt>(binsRemaining, 8); //code bytes if able to take advantage of the system's byte-write function
+    const UInt binMask    = (1 << binsToCode) - 1;
+
+    const UInt newBins = (binValues >> (binsRemaining - binsToCode)) & binMask;
+
+    //The process of encoding an EP bin is the same as that of coding a normal
+    //bin where the symbol ranges for 1 and 0 are both half the range:
+    //
+    //  low = (low + range/2) << 1       (to encode a 1)
+    //  low =  low            << 1       (to encode a 0)
+    //
+    //  i.e.
+    //  low = (low + (bin * range/2)) << 1
+    //
+    //  which is equivalent to:
+    //
+    //  low = (low << 1) + (bin * range)
+    //
+    //  this can be generalised for multiple bins, producing the following expression:
+    //
+    m_uiLow = (m_uiLow << binsToCode) + (newBins << 8); //range is known to be 256
+
+    binsRemaining -= binsToCode;
+    m_bitsLeft    -= binsToCode;
+
+    testAndWriteOut();
+  }
 }
 
@@ -314,7 +398,7 @@
     m_uiLow   <<= 1;
     m_uiRange <<= 1;
-    m_bitsLeft--;    
-  }
-  
+    m_bitsLeft--;
+  }
+
   testAndWriteOut();
 }
@@ -336,5 +420,5 @@
   m_bitsLeft += 8;
   m_uiLow &= 0xffffffffu >> m_bitsLeft;
-  
+
   if ( leadByte == 0xff )
   {
@@ -349,5 +433,5 @@
       m_bufferedByte = leadByte & 0xff;
       m_pcTComBitIf->write( byte, 8 );
-      
+
       byte = ( 0xff + carry ) & 0xff;
       while ( m_numBufferedBytes > 1 )
@@ -361,6 +445,6 @@
       m_numBufferedBytes = 1;
       m_bufferedByte = leadByte;
-    }      
-  }    
+    }
+  }
 }
 
Index: branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/TEncBinCoderCABAC.h
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/TEncBinCoderCABAC.h	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/TEncBinCoderCABAC.h	(revision 1200)
@@ -2,7 +2,7 @@
  * License, included below. This software may be subject to other third party
  * and contributor rights, including patent rights, and no such rights are
- * granted under this license.  
+ * granted under this license.
  *
-* Copyright (c) 2010-2015, ITU/ISO/IEC
+ * Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -36,6 +36,6 @@
 */
 
-#ifndef __TENC_BIN_CODER_CABAC__
-#define __TENC_BIN_CODER_CABAC__
+#ifndef __TENCBINCODERCABAC__
+#define __TENCBINCODERCABAC__
 
 #include "TLibCommon/TComCABACTables.h"
@@ -50,11 +50,11 @@
   TEncBinCABAC ();
   virtual ~TEncBinCABAC();
-  
+
   Void  init              ( TComBitIf* pcTComBitIf );
   Void  uninit            ();
-  
+
   Void  start             ();
   Void  finish            ();
-  Void  copyState         ( TEncBinIf* pcTEncBinIf );
+  Void  copyState         ( const TEncBinIf* pcTEncBinIf );
   Void  flush            ();
 
@@ -62,20 +62,24 @@
   Void  encodePCMAlignBits();
   Void  xWritePCMCode     ( UInt uiCode, UInt uiLength );
-  
+
   Void  resetBits         ();
   UInt  getNumWrittenBits ();
-  
+
   Void  encodeBin         ( UInt  binValue,  ContextModel& rcCtxModel );
   Void  encodeBinEP       ( UInt  binValue                            );
   Void  encodeBinsEP      ( UInt  binValues, Int numBins              );
   Void  encodeBinTrm      ( UInt  binValue                            );
-  
+
+  Void  align             ();
+  Void  encodeAlignedBinsEP( UInt  binValues, Int numBins             );
+
   TEncBinCABAC* getTEncBinCABAC()  { return this; }
-  
+  const TEncBinCABAC* getTEncBinCABAC() const { return this; }
+
   Void  setBinsCoded              ( UInt uiVal )  { m_uiBinsCoded = uiVal;               }
   UInt  getBinsCoded              ()              { return m_uiBinsCoded;                }
   Void  setBinCountingEnableFlag  ( Bool bFlag )  { m_binCountIncrement = bFlag ? 1 : 0; }
   Bool  getBinCountingEnableFlag  ()              { return m_binCountIncrement != 0;     }
-  
+
 #if FAST_BIT_EST
 protected:
@@ -85,5 +89,5 @@
   Void testAndWriteOut();
   Void writeOut();
-  
+
   TComBitIf*          m_pcTComBitIf;
   UInt                m_uiLow;
Index: branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/TEncBinCoderCABACCounter.cpp
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/TEncBinCoderCABACCounter.cpp	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/TEncBinCoderCABACCounter.cpp	(revision 1200)
@@ -2,7 +2,7 @@
  * License, included below. This software may be subject to other third party
  * and contributor rights, including patent rights, and no such rights are
- * granted under this license.  
+ * granted under this license.
  *
-* Copyright (c) 2010-2015, ITU/ISO/IEC
+ * Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -38,4 +38,6 @@
 #include "TEncBinCoderCABACCounter.h"
 #include "TLibCommon/TComRom.h"
+#include "TLibCommon/Debug.h"
+
 
 #if FAST_BIT_EST
@@ -72,8 +74,29 @@
 Void TEncBinCABACCounter::encodeBin( UInt binValue, ContextModel &rcCtxModel )
 {
+#if DEBUG_ENCODER_SEARCH_BINS
+  const UInt64 startingFracBits = m_fracBits;
+#endif
+
   m_uiBinsCoded += m_binCountIncrement;
-  
   m_fracBits += rcCtxModel.getEntropyBits( binValue );
   rcCtxModel.update( binValue );
+
+#if DEBUG_ENCODER_SEARCH_BINS
+  if ((g_debugCounter + debugEncoderSearchBinWindow) >= debugEncoderSearchBinTargetLine)
+  {
+    std::cout << g_debugCounter << ": coding bin value " << binValue << ", fracBits = [" << startingFracBits << "->" << m_fracBits << "]\n";
+  }
+
+  if (g_debugCounter >= debugEncoderSearchBinTargetLine)
+  {
+    Char breakPointThis;
+    breakPointThis = 7;
+  }
+  if (g_debugCounter >= (debugEncoderSearchBinTargetLine + debugEncoderSearchBinWindow))
+  {
+    exit(0);
+  }
+  g_debugCounter++;
+#endif
 }
 
@@ -83,5 +106,5 @@
  * \param binValue bin value
  */
-Void TEncBinCABACCounter::encodeBinEP( UInt binValue )
+Void TEncBinCABACCounter::encodeBinEP( UInt /*binValue*/ )
 {
   m_uiBinsCoded += m_binCountIncrement;
@@ -95,5 +118,5 @@
  * \param numBins number of bins
  */
-Void TEncBinCABACCounter::encodeBinsEP( UInt binValues, Int numBins )
+Void TEncBinCABACCounter::encodeBinsEP( UInt /*binValues*/, Int numBins )
 {
   m_uiBinsCoded += numBins & -m_binCountIncrement;
@@ -112,4 +135,9 @@
 }
 
+Void TEncBinCABACCounter::align()
+{
+  m_fracBits = (m_fracBits + 32767) & (~32767);
+}
+
 //! \}
 #endif
Index: branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/TEncBinCoderCABACCounter.h
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/TEncBinCoderCABACCounter.h	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/TEncBinCoderCABACCounter.h	(revision 1200)
@@ -2,7 +2,7 @@
  * License, included below. This software may be subject to other third party
  * and contributor rights, including patent rights, and no such rights are
- * granted under this license.  
+ * granted under this license.
  *
-* Copyright (c) 2010-2015, ITU/ISO/IEC
+ * Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -36,6 +36,6 @@
 */
 
-#ifndef __TENC_BIN_CODER_CABAC_COUNTER__
-#define __TENC_BIN_CODER_CABAC_COUNTER__
+#ifndef __TENCBINCODERCABACCOUNTER__
+#define __TENCBINCODERCABACCOUNTER__
 
 
@@ -53,5 +53,5 @@
   TEncBinCABACCounter ();
   virtual ~TEncBinCABACCounter();
-  
+
   Void  finish            ();
   UInt  getNumWrittenBits ();
@@ -61,5 +61,7 @@
   Void  encodeBinsEP      ( UInt  binValues, Int numBins              );
   Void  encodeBinTrm      ( UInt  binValue                            );
-  
+
+  Void  align             ();
+
 private:
 };
